#!/bin/bash

#This script for SWIFT use the fiber-storage
#setp1: Enable multipathd and use friendly name when overcloud update will skip 
#       because multipath configured
#step2: Find multipath disk /dev/sdb mapper name
#step3: Format disk
#setp4: mount to /srv/node

set -eux

#step1
if [ ! -f /etc/multipath.conf ]; then
    echo "Configure Multipath ..."
    mpathconf --enable --with_multipathd y
else
   echo "Multipath already configured."
   exit 0
fi

#Create the /srv/node if it doesn't exist
echo "Create Swift needed folder..."
if [ ! -d "/srv/node" ] ; then
    sudo mkdir -p /srv/node
    echo "Create Complete..."
else
    echo "This folder already exist skip..."
fi

#step2
echo "Format disk and mount..."
SCSI_ID="$(sudo /lib/udev/scsi_id -u -g /dev/sdb)"
SWIFT_DEVICE="$(sudo multipath -l | grep '${SCSI_ID}' | awk '{print $1}')"

#step3
if [ -n "${SWIFT_DEVICE}" ]; then
    #step3 & step4
    if ! mount | grep /dev/mapper/"$SWIFT_DEVICE";then
        sudo mkfs.xfs /dev/mapper/"$SWIFT_DEVICE"
        sudo mount -t xfs /dev/mapper/"$SWIFT_DEVICE" /srv/node
        echo "Write fstab for next reboot..."
        echo "/dev/mapper/$SWIFT_DEVICE /srv/node xfs defaults 0 0" | sudo tee -a /etc/fstab
    fi
else
    echo "Cloud not find swift device"
    exit 1
fi
echo "Configure complete...."
